(**
---------------------------------------------------------------------------------------------------------------------------------------------------------------
Copyright 2000, 2001, 2002, 2003, 2004, 2005 Dataprev - Empresa de Tecnologia e Informaes da Previdncia Social, Brasil

Este arquivo  parte do programa CACIC - Configurador Automtico e Coletor de Informaes Computacionais

O CACIC  um software livre; voc pode redistribui-lo e/ou modifica-lo dentro dos termos da Licena Pblica Geral GNU como
publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena, ou (na sua opinio) qualquer verso.

Este programa  distribuido na esperana que possa ser  util, mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAO a qualquer
MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software
Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
---------------------------------------------------------------------------------------------------------------------------------------------------------------
*)

unit Mapa;

interface

uses
  Windows,
  SysUtils,    // Deve ser colocado aps o Windows acima, nunca antes
  StrUtils,
  StdCtrls,
  Controls,
  Classes,
  Forms,
  ExtCtrls,
  Graphics,
  Dialogs,
  CACIC_Library,
  CACIC_Comm,
  CACIC_WMI,
  ComCtrls,
  Commctrl,
  ShellAPI,
  Types,
  IdIPWatch,
  Registry,
  Math,
  IdBaseComponent,
  IdComponent,
  Mask,
  ComObj,
  ldapsend,
  MultiMon;

function IsUserAnAdmin() : boolean; external shell32;

var strCollectsPatrimonioLast,
    strConfigsPatrimonioCombos,
    strFieldsAndValuesToRequest,
    strIdUON1,
    strFrmAtual,
    strShowOrHide               : string;
    textFileAguarde             : TextFile;
    boolFinalizando             : boolean;
    objCacic                    : TCACIC;
    Fechar                      : boolean;
    Dummy                       : integer;
    OldValue                    : LongBool;
    formSecondMonitor           : TForm;

type
  TfrmMapaCacic = class(TForm)
    edWebManagerAddress: TLabel;
    lbWebManagerAddress: TLabel;
    pnVersao: TPanel;
    timerMessageBoxShowOrHide: TTimer;
    timerMessageShowTime: TTimer;
    timerProcessos: TTimer;
    gbLeiaComAtencao: TGroupBox;
    lbLeiaComAtencao: TLabel;
    gbInformacoesSobreComputador: TGroupBox;
    lbEtiqueta2: TLabel;
    lbEtiqueta3: TLabel;
    lbEtiqueta4: TLabel;
    lbEtiqueta9: TLabel;
    lbEtiqueta10: TLabel;
    lbEtiqueta1: TLabel;
    lbEtiqueta5: TLabel;
    edTeInfoPatrimonio4: TEdit;
    edTeInfoPatrimonio3: TEdit;
    btCombosUpdate: TButton;
    edTeInfoPatrimonio2: TEdit;
    edTeInfoPatrimonio9: TEdit;
    edTeInfoPatrimonio1: TEdit;
    edTeInfoPatrimonio5: TEdit;
    bgTermoResponsabilidade: TGroupBox;
    rdConcordaTermos: TRadioButton;
    btGravarInformacoes: TButton;
    lbEtiqueta7: TLabel;
    edTeInfoPatrimonio6: TEdit;
    lbEtiqueta6: TLabel;
    edTeInfoPatrimonio7: TEdit;
    btKonamiCode: TPanel;
    edTeInfoPatrimonio10: TEdit;
    
    procedure FormCreate(Sender: TObject);
    procedure AtualizaPatrimonio(Sender: TObject);
    procedure mapa;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure btCombosUpdateClick(Sender: TObject);
    procedure timerProcessosTimer(Sender: TObject);
    procedure rdConcordaTermosClick(Sender: TObject);
    procedure EstadoBarraTarefa(EstadoBarra: Boolean);

    function getLastValue(S : String; separador, separador2 : string): string; 
    function LDAPName: string;
    function NomeComputador : String;
    function getConfigs : String;
//    function SetCpfUser : String;
//    function SetPatrimonioPC : String;
//    function FormatarCpf(strCpfUser : String) : String;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btKonamiCodeClick(Sender: TObject);


  private
    strTeInfoPatrimonio1,
    strTeInfoPatrimonio2,
    strTeInfoPatrimonio3,
    strTeInfoPatrimonio4,
    strTeInfoPatrimonio5,
    strTeInfoPatrimonio6,
    strTeInfoPatrimonio7,
    strTeInfoPatrimonio8,
    strTeInfoPatrimonio9,
    strTeInfoPatrimonio10,
    strTeInfoPatrimonioTel     : String;
    psswd : String;
    foco : boolean;

    procedure FormSetFocus(VerificaFoco: Boolean);
    procedure MontaInterface;
    procedure RecuperaValoresAnteriores;
    procedure Sair;

  public
    boolAcessoOK                : boolean;
    strId_usuario,
    strChkSisInfFileName,
    strGerColsInfFileName       : String;

    procedure Finalizar;

  end;

const SENHA = 'uuddlrlrba';

var frmMapaCacic: TfrmMapaCacic;

implementation

{$R *.dfm}


procedure TfrmMapaCacic.Sair;
Begin
    Application.Terminate;
End;

procedure TfrmMapaCacic.Finalizar;
Begin
  Visible                               := false;

  if FileExists(objCACIC.getLocalFolderName + '\temp\aguarde_MAPACACIC.txt') then
      objCACIC.deleteFileOrFolder(objCacic.getLocalFolderName +
                                  '\temp\aguarde_MAPACACIC.txt');
  objCacic.setValueToFile('Configs', 'Patrimonio', 'false', strGercolsInfFileName);
  Application.ProcessMessages;

  Sair;
End;

procedure TfrmMapaCacic.rdConcordaTermosClick(Sender: TObject);
begin
  btGravarInformacoes.Enabled:= true;
end;

//------------------------------------------------------------------------------
//------------------FUNO PARA RETORNAR O NOME DO COMPUTADOR.------------------
//------------------------------------------------------------------------------

Function TfrmMapaCacic.NomeComputador : String;
var
  lpBuffer : PChar;
  nSize : DWord;
const Buff_Size = MAX_COMPUTERNAME_LENGTH + 1;
begin
  nSize := Buff_Size;
  lpBuffer := StrAlloc(Buff_Size);
  GetComputerName(lpBuffer,nSize);
  Result := String(lpBuffer);
  StrDispose(lpBuffer);
end;

//------------------------------------------------------------------------------
//----------------------FUNO PARA RETORNAR O PATRIMONIO-----------------------
//------------------------------------------------------------------------------

//function TfrmMapaCacic.SetPatrimonioPC : String;
//var
//  strPatrimonioPc,
//  strNomePC        : String;
//begin
//  Result:='';
//  strNomePC:=NomeComputador;
//
//  if (pos('-',strNomePC) > 0) then
//    strPatrimonioPc:=copy(strNomePC, 0, (pos('-', strNomePC)-1));
//  Result:=strPatrimonioPC;
//end;

//------------------------------------------------------------------------------
//--------------------FUNO PARA FORMATAR O CPF--------------------------------
//------------------------------------------------------------------------------

//function TfrmMapaCacic.FormatarCpf(strCpfUser : String) : String;
//var
//  strCpfFormatado : String;
//begin
//  Result:='';
//  strCpfFormatado:= Copy(strCpfUser, 1,3)
//
//            + '.' + Copy(strCpfUser, 4,3)
//
//            + '.' + Copy(strCpfUser, 7,3)
//
//            + '-' + Copy(strCpfUser, 10,2);
//  Result:=strCpfFormatado;
//
//end;
//------------------------------------------------------------------------------
//--------------------FUNO PARA RETORNAR O CPF DO USUARIO---------------------
//------------------------------------------------------------------------------

//function TfrmMapaCacic.SetCpfUser : String;
//var
//  strCpfUser,
//  strUser        : String;
//begin
//  Result:='';
//  strUser:=strTeInfoPatrimonio3;
//
//  if (pos('-',strUser) > 0) then
//    strCpfUser:=copy(strUser, 0, (pos('-', strUser)-1));
//
//  Result:=strCpfUser;
//end;

//------------------------------------------------------------------------------
//--------------------FUNO PARA RETORNAR O ULTIMO VALOR-----------------------
//-----------------------APS O SEPARADOR SELECIONADO---------------------------
//------------------------------------------------------------------------------

function TfrmMapaCacic.getLastValue(S : String; separador, separador2 : string): string;
  var
  conta, tamanho_separador, tamanho_separador2 : integer;         // variveis auxiliares
  resultado : TStringList; // variveis auxiliares
  Saux, index : string;           // variveis auxiliares
begin
    resultado := TStringList.Create;   // inicializa variavel
    tamanho_separador:= Length(separador);
    tamanho_separador2:= Length(separador2);
    index:=copy(separador2, 1, pos(#$D#$A, separador2)-1);
    conta := pos(separador,S)+tamanho_separador;         // pega posio do separador
    if conta <> 0 then begin           // verifica se existe o separador caso contrario trata apenas //como uma nica linha
        while trim(S) <> '' do begin   // enquanto S no for nulo executa
            Saux := copy(S,1,conta-1); // Varivel Saux recebe primeiro valor
            delete(S,1,conta);         // deleta primeiro valor
            if conta = 0 then begin    // se no ouver mais separador Saux equivale ao resto da //linha
                Saux := S;
                S := '';
            end;
            if pos(separador2, Saux)>0 then begin
              delete(Saux, 1, tamanho_separador2);
              resultado.values[index]:=
                copy(Saux,1,pos(#$D#$A, Saux));
              break;
            end;
            resultado.add(Saux);           // adiciona linhas na string lista
            conta := pos(separador,S);     //pega posio do separador
        end;
    end
    else begin
        Saux := S;
        resultado.Add(Saux);
    end;
    Result := trim(resultado.values[index]); // retorna resultado como uma lista indexada
end;

//------------------------------------------------------------------------------
//--------------------FUNO PARA PEGAR CONFIGURAES NO GERENTE----------------
//------------------------------------------------------------------------------

function TfrmMapaCacic.getConfigs : String;
var
   teste : string;
Begin
  btCombosUpdate.Enabled := false;
  objCACIC.writeDebugLog('getConfigs: Invocando getConfigs...');
  Result := Comm(objCacic.getWebManagerAddress + objCacic.getWebServicesFolderName + 'get/config', strFieldsAndValuesToRequest, objCacic.getLocalFolderName);

  objCacic.setBoolCipher(not objCacic.isInDebugMode);
  objCacic.writeDebugLog('FormActivate: Retorno de getConfigs: "'+Result+'"');

  if (Result <> '0') then
    Begin
      objCACIC.writeDebugLog('getConfigs: Comunicao realizada com sucesso!');
      objCacic.setValueToFile('Configs' ,'servidor_autenticacao', objCacic.getValueFromTags('dados_ldap'                  , Result), strGerColsInfFileName);
      objCacic.setValueToFile('Configs' ,'Patrimonio_Combos'    , objCacic.getValueFromTags('Configs_Patrimonio_Combos'   , Result), strGerColsInfFileName);
      objCacic.setValueToFile('Configs' ,'Patrimonio_Interface' , objCacic.getValueFromTags('Configs_Patrimonio_Interface', Result), strGerColsInfFileName);
    End
  else
    begin
      objCACIC.writeDailyLog('No foi possvel realizar a conexo!');
    end;
  btCombosUpdate.Enabled := true;
End;

//------------------------------------------------------------------------------
//--------------------PROCEDIMENTO UTILIZADO PARA PEGAR AS ULTIMAS--------------
//----------------------INFORMAES ENVIADAS PELO MAPACACIC---------------------

procedure TfrmMapaCacic.RecuperaValoresAnteriores;
var strCollectsPatrimonioLast : String;
begin
  objCACIC.writeDebugLog('RecuperaValoresAnteriores: Incio.');
  btCombosUpdate.Enabled := false;

  strCollectsPatrimonioLast := objCacic.deCrypt( objCacic.GetValueFromFile
                                                ('Collects','col_patr_last',
                                                 strGerColsInfFileName));

  if (strCollectsPatrimonioLast <> '') then
    Begin

      if (strTeInfoPatrimonio1='') then
        strTeInfoPatrimonio1 := objCacic.getValueFromTags('IDPatrimonio',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio2='') then
        strTeInfoPatrimonio2 := objCacic.getValueFromTags('PatrimonioMonitor1',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio3='') then
        strTeInfoPatrimonio3 := objCacic.getValueFromTags('PatrimonioMonitor2',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio4='') then
        strTeInfoPatrimonio4 := objCacic.getValueFromTags('UserLogado',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio5='') then
        strTeInfoPatrimonio5 := objCacic.getValueFromTags('UserName',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio6='') then
        strTeInfoPatrimonio6 := objCacic.getValueFromTags('Coordenacao_Setor',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio7='') then
        strTeInfoPatrimonio7 := objCacic.getValueFromTags('Sala',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonioTel='') then
        strTeInfoPatrimonioTel := objCacic.getValueFromTags('Tel',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio8='') then
        strTeInfoPatrimonio8 := objCacic.getValueFromTags('Ramal',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio9='') then
        strTeInfoPatrimonio9 := objCacic.getValueFromTags('ComputerName',
                                                          strCollectsPatrimonioLast);
      if (strTeInfoPatrimonio10='') then
        strTeInfoPatrimonio10 := objCacic.getValueFromTags('IPComputer',
                                                          strCollectsPatrimonioLast);
    End;
  btCombosUpdate.Enabled := true;
  Application.ProcessMessages;
  objCACIC.writeDebugLog('RecuperaValoresAnteriores: Fim.');
end;

procedure TfrmMapaCacic.AtualizaPatrimonio(Sender: TObject);
var strColetaAtual,
    strRetorno: String;
begin
if edTeInfoPatrimonio5.text <> '' then
  begin
    btGravarInformacoes.Enabled := false;
    btGravarInformacoes.Caption := 'Enviando informaes...';
    objCACIC.writeDebugLog('Preparando para o envio das informaes...');
    strFieldsAndValuesToRequest := 'CollectType=' + objCacic.replaceInvalidHTTPChars(objCacic.enCrypt('col_patr')) ;

    strColetaAtual := StringReplace('[IDPatrimonio]'         + edTeInfoPatrimonio1.Text   + '[/IDPatrimonio]'       +
                                    '[PatrimonioMonitor1]'   + edTeInfoPatrimonio2.Text   + '[/PatrimonioMonitor1]' +
                                    '[PatrimonioMonitor2]'   + edTeInfoPatrimonio3.Text   + '[/PatrimonioMonitor2]' +
                                    '[UserLogado]'           + edTeInfoPatrimonio4.Text   + '[/UserLogado]'         +
                                    '[UserName]'             + edTeInfoPatrimonio5.Text   + '[/UserName]'           +
                                    '[Coordenacao_Setor]'    + edTeInfoPatrimonio6.Text   + '[/Coordenacao_Setor]'  +
                                    '[Sala]'                 + edTeInfoPatrimonio7.Text   + '[/Sala]'               +
                                    '[ComputerName]'         + edTeInfoPatrimonio9.text   + '[/ComputerName]'       +
                                    '[IPComputer]'           + edTeInfoPatrimonio10.text  + '[/IPComputer]'
                                    , ',','[[COMMA]]',[rfReplaceAll]);

    strFieldsAndValuesToRequest := strFieldsAndValuesToRequest + ',Patrimonio='  +
                                   objCacic.replaceInvalidHTTPChars(objCacic.enCrypt(strColetaAtual));

    strRetorno := Comm(objCacic.getWebManagerAddress + objCacic.getWebServicesFolderName +
                        'gercols/set/collects', strFieldsAndValuesToRequest, objCacic.getLocalFolderName);

    objCacic.setBoolCipher(not objCacic.isInDebugMode);

    if (strRetorno = '0') then
    begin
       btGravarInformacoes.caption := 'Problema ao enviar informaes...';
       Application.messagebox(Pchar('Ateno!'+ #13#10 + 'Problema ao enviar as informaes!'
               + #13#10 + 'Se o problema persistir contate o adminsitrador.'), 'Erro!',MB_ICONERROR + mb_ok);
    end
    else
    Begin
        objCACIC.writeDailyLog('Envio realizado com sucesso.');
        btGravarInformacoes.Caption := 'Informaes enviadas com sucesso...';
        objCacic.setValueToFile('Collects','col_patr_last' ,
                                objCacic.enCrypt(strColetaAtual), strGerColsInfFileName);
    End;
    objCacic.writeDebugLog(#13#10 + 'AtualizaPatrimonio: Dados Enviados ao Servidor!');
    Application.ProcessMessages;
    Finalizar;
  end
  else
    Application.messagebox(Pchar('Por favor,  necessrio digitar seu nome!'), 'Ateno!',MB_ICONEXCLAMATION + mb_ok);
end;


procedure TfrmMapaCacic.MontaInterface;
var strConfigsPatrimonioInterface,
    termosPatrimonio,
    strNomeLDAP : String;
    count : integer;
Begin
    count := 0;
    btCombosUpdate.Enabled := false;

    strConfigsPatrimonioInterface := objCacic.deCrypt(objCacic.getValueFromFile
                                                      ('Configs','Patrimonio_Interface',
                                                      strGerColsInfFileName));
    termosPatrimonio := objCacic.getValueFromFile('Configs', 'termos_patrimonio', strGercolsInfFileName);

//-------------------------PATRIMONIO DA MAQUINA--------------------------------
{   edTePatrimonioPc.Text                     := SetPatrimonioPc;
   if edTePatrimonioPc.Text <> '' then
   Begin
      lbEtiquetaPatrimonioPc.Visible         := true;
      edTePatrimonioPc.Visible               := true;
   end;}
    edTeInfoPatrimonio1.Text        := strTeInfoPatrimonio1;
    edTeInfoPatrimonio1.Visible     := true;
    lbEtiqueta1.Visible             := true;

//   objCacic.writeDebugLog('MontaInterface: in_exibir_etiqueta2 -> "'     +
//                          objCacic.getValueFromTags('in_exibir_etiqueta2',
//                                                   strConfigsPatrimonioInterface)+'"');

//   if (trim(objCacic.getValueFromTags('in_exibir_etiqueta2', strConfigsPatrimonioInterface)) = 'S') then
//   begin
      //lbEtiqueta3.Caption         := objCacic.getValueFromTags('te_etiqueta2', strConfigsPatrimonioInterface);
       lbEtiqueta2.Visible          := true;
       edTeInfoPatrimonio2.Text     := strTeInfoPatrimonio2;
       edTeInfoPatrimonio2.visible  := True;
//   end;

//   objCacic.writeDebugLog('MontaInterface: in_exibir_etiqueta3 -> "'     +
//                          objCacic.getValueFromTags('in_exibir_etiqueta3',
//                                                   strConfigsPatrimonioInterface)+'"');

//   if (trim(objCacic.getValueFromTags('in_exibir_etiqueta3', strConfigsPatrimonioInterface)) = 'S') then
//   begin
      //lbEtiqueta3.Caption         := objCacic.getValueFromTags('te_etiqueta3', strConfigsPatrimonioInterface);
       lbEtiqueta3.Visible          := true;
       edTeInfoPatrimonio3.Text     := strTeInfoPatrimonio3;
       edTeInfoPatrimonio3.visible  := True;
//   end;

//-----------------------------USUARIO LOGADO-----------------------------------

//    edTeInfoUserLogado.Text                   := getUserLogon;
    strTeInfoPatrimonio4 := '';
    while(strTeInfoPatrimonio4 = '') and (count < 600) do
    begin
      strTeInfoPatrimonio4    := objCACIC.getValueFromTags('UserName',fetchWMIvalues('Win32_ComputerSystem',objCACIC.getLocalFolderName,'UserName'));
      strTeInfoPatrimonio4    := copy(strTeInfoPatrimonio4, pos('\', strTeInfoPatrimonio4)+1, length(strTeInfoPatrimonio4));
      edTeInfoPatrimonio4.Text:= strTeInfoPatrimonio4;
      sleep(1000);
      count := count + 1;
    end;

    if edTeInfoPatrimonio4.Text <> '' then
    begin
       lbEtiqueta4.Visible          := true;
       edTeInfoPatrimonio4.Visible  := true;
    end;

    //-------------------------------NOME USUARIO-----------------------------------
    strNomeLDAP := getLastValue(LDAPName, 'Attribute:', 'cn'+#$D#$A);


    if (strNomeLDAP <> '') and (strNomeLDAP <> 'Results: 0') then
    begin
       edTeInfoPatrimonio5.Text     := strNomeLDAP;
       edTeInfoPatrimonio5.Visible  := true;
       lbEtiqueta5.Visible          := true;
       lbEtiqueta5.ShowHint         := true;
       lbEtiqueta5.hint             := 'Nome do usurio logado.';
    end
    else
    begin
       edTeInfoPatrimonio5.Visible  := true;
       edTeInfoPatrimonio5.Enabled  := true;
       lbEtiqueta5.Visible          := true;
       lbEtiqueta5.ShowHint         := true;
       lbEtiqueta5.hint             := 'Digite seu nome, no foi possvel recuper-lo.';
       objCacic.writeDailyLog('No foi possvel pegar nome do ldap');
    end;

//   objCacic.writeDebugLog('MontaInterface: in_exibir_etiqueta6 -> "'     +
//                          objCacic.getValueFromTags('in_exibir_etiqueta6',
//                                                    strConfigsPatrimonioInterface)+'"');

//   if (trim(objCacic.getValueFromTags('in_exibir_etiqueta6', strConfigsPatrimonioInterface)) = 'S') then
//   begin
      //lbEtiqueta6.Caption         := objCacic.getValueFromTags('te_etiqueta6', strConfigsPatrimonioInterface);
      lbEtiqueta6.Visible           := true;
      edTeInfoPatrimonio6.Hint      := objCacic.getValueFromTags('te_help_etiqueta6', strConfigsPatrimonioInterface);
      edTeInfoPatrimonio6.Text      := strTeInfoPatrimonio6;
      edTeInfoPatrimonio6.visible   := True;
//   end;

//   objCacic.writeDebugLog('MontaInterface: in_exibir_etiqueta7 -> "'     +
//                          objCacic.getValueFromTags('in_exibir_etiqueta7',
//                                                    strConfigsPatrimonioInterface)+'"');

//   if (trim(objCacic.getValueFromTags('in_exibir_etiqueta7', strConfigsPatrimonioInterface)) = 'S') then
//   begin
      //lbEtiqueta7.Caption         := objCacic.getValueFromTags('te_etiqueta7', strConfigsPatrimonioInterface);
      lbEtiqueta7.Visible           := true;
      edTeInfoPatrimonio7.Hint      := objCacic.getValueFromTags('te_help_etiqueta7', strConfigsPatrimonioInterface);
      edTeInfoPatrimonio7.Text      := strTeInfoPatrimonio7;
      edTeInfoPatrimonio7.visible   := True;
//   end;

//-----------------------NOME DO COMPUTADOR PARA O EDTEXT-----------------------
    edTeInfoPatrimonio9.Text               := NomeComputador;
    if edTeInfoPatrimonio9.Text <> '' then
    begin
       lbEtiqueta9.Visible          := true;
       edTeInfoPatrimonio9.Visible  := true;
    end;
    lbEtiqueta9.Visible             := true;
    edTeInfoPatrimonio9.Visible     := true;

//-----------------------PUXA O IP DA MQUINA PARA O EDTEXT-------------------------------------
    strTeInfoPatrimonio10            := fetchWMIvalues('Win32_NetworkAdapterConfiguration', objCACIC.getLocalFolderName);
    edTeInfoPatrimonio10.Text        := objCACIC.getValueFromTags('IPAddress',strTeInfoPatrimonio10);
    if edTeInfoPatrimonio10.Text <> '' then
    begin
       lbEtiqueta10.Visible          := true;
       edTeInfoPatrimonio10.Visible  := true;
    end;

    if termosPatrimonio <> '' then
      rdConcordaTermos.Caption := termosPatrimonio;

    btGravarInformacoes.Visible := true;
    btCombosUpdate.Enabled      := true;
    Application.ProcessMessages;
    objCACIC.writeDebugLog('Interface criada com sucesso.');
end;

procedure TfrmMapaCacic.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If Not fechar Then //se a variavel de fechamento fecha estiver falsa
    Action := caNone // nao realizar  nenhuma operao
  Else
  begin
    Action := caFree;
    formSecondMonitor:=nil;
    objCacic.writeDebugLog('FormClose: ' + Sender.ClassName);
    Finalizar;
  end;
end;


procedure TfrmMapaCacic.mapa;
begin
  Try
    RecuperaValoresAnteriores;
    MontaInterface;
  Except
    on E:Exception do
       Begin
         Application.messagebox(Pchar('Problemas ao gerar formulrio.'), 'Erro!',MB_ICONERROR + mb_ok);
//         EstadoBarraTarefa(TRUE);
         objCacic.writeExceptionLog(E.Message,e.ClassName);
         Finalizar;
       End;
  End;
End;

procedure TfrmMapaCacic.FormCreate(Sender: TObject);

begin
  psswd := '';
  KeyPreview := true;
  frmMapaCacic.boolAcessoOK := true;
//Definido TRUE, se no, mesmo que o foco seja falso, a aplicao no  fechada quando quiser.
  Fechar:=TRUE;
  foco:=true; //DEFINIDO COMO TRUE PARA QUE A JANELA NO SEJA FECHADA

  
  Try
    strFrmAtual  := 'Principal';
    objCacic     := TCACIC.Create();

    objCacic.setBoolCipher(true);
    objCacic.setLocalFolderName('Cacic');
    objCacic.setWebServicesFolderName('/ws');

    if IsUserAnAdmin then
    begin
      strChkSisInfFileName := objCacic.getWinDir + 'chksis.inf';

      if not (objCacic.GetValueFromFile('Configs','LocalFolderName',
                                         strChkSisInfFileName) = '') then

      Begin

        objCacic.setLocalFolderName(objCacic.GetValueFromFile
                                    ('Configs', 'LocalFolderName',
                                     strChkSisInfFileName));

        objCacic.setWebServicesFolderName(objCacic.GetValueFromFile
                                          ('Configs','WebServicesFolderName',
                                            strChkSisInfFileName));

        objCacic.setWebManagerAddress(objCacic.GetValueFromFile
                                      ('Configs','WebManagerAddress',
                                        strChkSisInfFileName));


        strGerColsInfFileName := objCacic.getLocalFolderName + 'GerCols.inf';

        // A existncia e bloqueio do arquivo abaixo evitar que o Agente Principal entre em ao

        AssignFile(textFileAguarde,objCacic.getLocalFolderName +
                   '\temp\aguarde_MAPACACIC.txt'); //Associa o arquivo a uma varivel do tipo TextFile

        {$IOChecks off}

        reset(textFileAguarde);

        {$IOChecks on}
        if (IOResult <> 0) then // Arquivo no existe, ser recriado.
            rewrite (textFileAguarde); //Abre o arquivo texto

        Append(textFileAguarde);
        Writeln(textFileAguarde,'Apenas um pseudo-cookie para o Agente Principal esperar o trmino de MapaCACIC');
        Append(textFileAguarde);

        frmMapaCacic.edWebManagerAddress.Caption := objCacic.GetValueFromFile('Configs','WebManagerAddress', strChkSisInfFileName);

        objCacic.writeDebugLog('FormActivate: Verso do MapaCacic...: '    +
                                pnVersao.Caption);
        ObjCacic.writeDebugLog('FormActivate: Hash-Code do MapaCacic: '    +
                                objCacic.getFileHash(ParamStr(0)));

        // Povoamento com dados de configuraes da interface patrimonial
        // Solicita ao servidor as configuraes para a Coleta de Informaes de Patrimnio
        objCacic.writeDebugLog('FormActivate: Requisitando informaes de patrimnio da estao...');

        if getConfigs <> '0' then
        begin
          if (objCACIC.getValueFromFile('Configs',
                                        'Patrimonio',
                                        strGerColsInfFileName) = 'true') then
          begin
            objCACIC.writeDebugLog('Iniciando formulrio.');
            mapa;
            FormSetFocus(foco)
          end
          else
          begin
            objCACIC.writeDailyLog('Modulo desabilitado.');
            Finalizar;
          end;
        end
        else
        begin
           objCACIC.writeDailyLog('Falha ao pegar informaes!.');
           Finalizar;
        end;
      end
      else
      Begin
        frmMapaCacic.boolAcessoOK := false;
        objCACIC.writeDailyLog('Ateno!  necessrio reinstalar o CACIC nesta estao. A estrutura encontra-se corrompida.');
        Finalizar;
      End;
    end
    else
    Begin // Se NT/2000/XP/...
      Application.messagebox(Pchar('ATENO! Essa aplicao requer execuo com nvel administrativo.'), 'Erro!',MB_ICONERROR + mb_ok);
      objCacic.writeDailyLog('SEM PRIVILGIOS: Necessrio ser administrador "local" ou de Domnio!');
      Finalizar;
    End;
    Except
      on E:Exception do
        Begin
          objCacic.writeExceptionLog(E.Message,e.ClassName + 'Erro ao criar formulario.');
          objCACIC.writeDailyLog('Erro ao criar formulario.');
          Finalizar;
      End; //on E:Exception do
    end;
end;


procedure TfrmMapaCacic.FormActivate(Sender: TObject);

begin
  pnVersao.Caption := 'Verso: ' + objCacic.getVersionInfo(ParamStr(0));
  strFrmAtual := 'Principal';
  //ESCONDE APLICAO DA TASKBAR -- DEVE SER COLOCADA NO OnActivate
  Application.MainFormOnTaskBar:=FALSE;
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TfrmMapaCacic.btCombosUpdateClick(Sender: TObject);
begin

  getConfigs;
  RecuperaValoresAnteriores;
  MontaInterface;

end;

procedure TfrmMapaCacic.btKonamiCodeClick(Sender: TObject);
begin
  finalizar;
end;

//------------------------------------------------------------------------------
//PROCEDURE CRIADO PARA DEIXAR O FORM FULLSCREEN E FOCADO, SEM QUE SEJA POSSVEL
//FECHAR OU ALTERNAR ENTRE OUTRAS JANELAS AT QUE ATUALIZE O PATRIMONIO.
procedure TfrmMapaCacic.FormSetFocus(VerificaFoco: Boolean);
var
  r : TRect;
begin
  if VerificaFoco then
  begin
    Fechar                    := False;
    BorderIcons               := BorderIcons - [biSystemMenu] - [biMinimize] - [biMaximize];
    BorderStyle               := bsNone;
    FormStyle                 := fsStayOnTop;
    Position                  := poOwnerFormCenter;
    timerProcessos.Enabled    := True;
    SystemParametersInfo(SPI_GETWORKAREA, 0, @r,0);
    SetBounds(r.Left, r.Top, r.Right-r.Left, r.Bottom-r.Top);
    Top := Screen.WorkAreaTop;
    Left := Screen.WorkAreaLeft;
    Width := Screen.WorkAreaWidth;
    Height := Screen.Height;
    {    if Screen.MonitorCount>1 then
    begin
      formSecondMonitor := TForm.Create(nil);
      for i := 0 to Screen.MonitorCount - 1 do
      begin
        if not Screen.Monitors[i].Primary then
          formSecondMonitor.WindowState := wsNormal;
          formSecondMonitor.BorderStyle := bsNone;
          formSecondMonitor.Width := Screen.Monitors[i].Width;
          formSecondMonitor.Height := Screen.Monitors[i].Height;
          formSecondMonitor.top := Screen.Monitors[i].top;
          formSecondMonitor.left := Screen.Monitors[i].left;
          formSecondMonitor.Enabled := true;
          formSecondMonitor.Visible:=true;
      end;
    end;
       }

//  EstadoBarraTarefa(FALSE);

  end;

end;

//CODE PRA FECHAR O MAPA SEM PRESSIONAR NADA. (up + up + down + down + <- + -> + <- + -> + B + A)
procedure TfrmMapaCacic.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

begin
  case Key of
    VK_Left : psswd:=psswd+'l';
    VK_Right : psswd:=psswd+'r';
    VK_Up : psswd:=psswd+'u';
    VK_Down : psswd:=psswd+'d';
    65 : psswd:=psswd+'a';
    66 : psswd:=psswd+'b';
    else
      psswd:='';
  end;
  if psswd = SENHA then begin
    FormStyle                 := fsNormal;
    MessageDlg('KONAMICODE ACTIVATED!',mtWarning, [mbOK], 0);
    btKonamiCode.Left    := width-btKonamiCode.Width;
    btKonamiCode.visible := true;
    btKonamiCode.enabled := true;
  end;
end;


//------------------------------------------------------------------------------
//----------------ESCONDE BARRA DE TAREFAS--------------------------------------
//------------------------------------------------------------------------------

procedure TfrmMapaCacic.EstadoBarraTarefa(EstadoBarra: Boolean);

var wndHandle : THandle;
    wndClass  : array[0..50] of Char;

begin

  StrPCopy(@wndClass[0],'Shell_TrayWnd');
  wndHandle := FindWindow(@wndClass[0], nil);

  If EstadoBarra=True Then
    ShowWindow(wndHandle, SW_RESTORE) {Mostra a barra de tarefas}

  Else
    ShowWindow(wndHandle, SW_HIDE); {Esconde a barra de tarefas}

end;

//------------------------------------------------------------------------------
//-----------------BEGIN-----RETIRA PROCESSO DO GERENCIADOR---------------------
//------------------------------------------------------------------------------

procedure TfrmMapaCacic.timerProcessosTimer(Sender: TObject);
var
  dwSize,dwNumBytes,PID,hProc: Cardinal;
  PLocalShared,PSysShared: PlvItem;
  h: THandle;
  iCount,i: integer;
  szTemp: string;
begin
  //Pega o Handle da ListView
  h:=FindWindow('#32770',nil);
  h:=FindWindowEx(h,0,'#32770',nil);
  h:=FindWindowEx(h,0,'SysListView32',nil);

  //Pega o nmero de itens da ListView
  iCount:=SendMessage(h, LVM_GETITEMCOUNT,0,0);
  for i:=0 to iCount-1 do
    begin
    //Define o tamanho de cada item da ListView
    dwSize:=sizeof(LV_ITEM) + sizeof(CHAR) * MAX_PATH;

    //Abre um espao na memria do NOSSO programa para o PLocalShared
    PLocalShared:=VirtualAlloc(nil, dwSize, MEM_RESERVE + MEM_COMMIT, PAGE_READWRITE);

    //Pega o PID do processo taskmgr
    GetWindowThreadProcessId(h,@PID);

    //Abre o processo taskmgr
    hProc:=OpenProcess(PROCESS_ALL_ACCESS,false,PID);

    //Abre um espao na memria do taskmgr para o PSysShared
    PSysShared:=VirtualAllocEx(hProc, nil, dwSize, MEM_RESERVE OR MEM_COMMIT, PAGE_READWRITE);

    //Define as propriedades do PLocalShared
    PLocalShared.mask:=LVIF_TEXT;
    PLocalShared.iItem:=0;
    PLocalShared.iSubItem:=0;
    PLocalShared.pszText:=LPTSTR(dword(PSysShared) + sizeof(LV_ITEM));
    PLocalShared.cchTextMax:=20;

    //Escreve PLocalShared no espao de memria que abriu no taskmgr
    WriteProcessMemory(hProc,PSysShared,PLocalShared,1024,dwNumBytes);

    //Pega o texto to item i e passa pro PSysShared
    SendMessage(h,LVM_GETITEMTEXT,i,LPARAM(PSysShared));

    //Passa o PSysShared para o PLocalShared
    ReadProcessMemory(hProc,PSysShared,PLocalShared,1024,dwNumBytes);

    //Passa o texto do Item para szTemp
    szTemp:=pchar(dword(PLocalShared)+sizeof(LV_ITEM));

    //Se esse texto contiver a string proc deleta o item
    if LowerCase(szTemp) = 'mapacacic.exe' then
      ListView_DeleteItem(h,i);

    //Libera os espaos de memria utilizados
    VirtualFree(pLocalShared, 0, MEM_RELEASE);
    VirtualFreeEx(hProc, pSysShared, 0, MEM_RELEASE);

    //Fecha o handle do processo
    CloseHandle(hProc);
  end;
end;

function TfrmMapaCacic.LDAPName: string;
var
  retorno: TStringList;
  i: integer;
  host, username, psswd, base, strDadosLDAP, aux, identificador : string;
  ldap: TLDAPsend;

begin
  result            := '';

//  PEGANDO OS DADOS DO POR MEIO DO GET/CONFIGS, ONDE SER GRAVADO NO GERCOLS.INF
  strDadosLDAP := objCacic.deCrypt(objCacic.getValueFromFile('Configs','servidor_autenticacao',strGerColsInfFileName));
  if strDadosLDAP<>'' then
  begin
    ldap              := TLDAPsend.Create;
    retorno           := TStringList.Create;

    host         := objCacic.getValueFromTags('ip', strDadosLDAP);
    username     := objCacic.getValueFromTags('usuario', strDadosLDAP);
    psswd        := objCacic.getValueFromTags('senha', strDadosLDAP);
    base         := objCacic.getValueFromTags('base', strDadosLDAP);
    identificador:= objCacic.getValueFromTags('identificador', strDadosLDAP);
    for i := 0 to 2 do //At 2 porque so no mxio 3 identificadores que sero passados.
    begin
      aux:=objCacic.getValueFromTags('retorno'+IntToStr(i+1), strDadosLDAP);
      if aux<>'' then
        retorno.Add(aux);
    end;
    if (host<>'') and (base<>'') and (retorno.count<>0) and (username<>'') then
    begin
      try
        try
         objCACIC.writeDebugLog('Nome Usurio: Estabelecendo conexo.');
         ldap.TargetHost := host;
         ldap.UserName   := username;
         ldap.Password   := psswd;
         ldap.Timeout    := 5000;
         if ldap.Login and ldap.Bind then    //Loga no LDAP e autentica no LDAP com Usurio e senha repassado. (BindSasl  mais seguro que Bind)
         begin
          ldap.Search(base, False, identificador+ '=' + strTeInfoPatrimonio4, retorno); //Faz a pesquisa, com o CPF repassado.
          result := LDAPResultdump(ldap.SearchResult);
          objCACIC.writeDebugLog('Nome Usurio: Conexo estabelecida, pesquisa realizada.');
          ldap.Logout;
         end;
        finally
         ldap.Free;
         retorno.Free;
        end;
      Except
        on E:Exception do
           Begin
             objCacic.writeExceptionLog(E.Message,e.ClassName);
             objCACIC.writeDailyLog('Nome Usurio: Falha ao tentar recuperar o nome.');
           End; //on E:Exception do
      end; // Try
    end; // if (host<>'') or (base<>'') or (retorno.count=0) then
  end  //if strDadosLDAP<>'' then
  else
    objCACIC.writeDailyLog('Nome Usurio: Dados do servidor de autenticao inexistentes.');
end;




end.
