/* 
 * Classe que trata os eventos da janela de autenticao.
 */

#ifndef _WINVNC_VNCPASSDIALOG
#define _WINVNC_VNCPASSDIALOG

#include "stdhdrs.h"
#include "resource.h"

#include "vncPasswd.h"

#include <vector>
using namespace std;
#include <string>
using namespace std;

#include "CACIC_Utils.h"

//extern int MAX_VNC_CLIENTS;

#define ATT_MSG "ATENO: Esta autenticao, que precede a abertura de sesso para suporte remoto, atribui ao usurio a total responsabilidade por todo e qualquer tipo de dano lgico  estao que porventura seja causado por acesso externo indevido."

#pragma once

class vncPassDlg {

public:
	static enum EAuthCode { AUTENTICADO = 1, // usuario autenticado
							FALHA_AUTENTICACAO = 2, // falha ao autenticar, ex: usurio e/ou senha invlidos
							ESPERANDO_AUTENTICACAO = 3,  // autenticao ainda no efetuada
							SEM_AUTENTICACAO = 4 }; // no necessita de autenticao

	vncPassDlg(vector<Dominio> &listaDominios);
	virtual ~vncPassDlg();

	char m_usuario[33]; // nome de usurio
	char m_senha[33]; // senha de usurio
	char m_dominio[17]; // id do domnio selecionado

	vector<Dominio> m_listaDominios;

	EAuthCode m_authStat;
	string m_msgInfo;

	// Campo extra para fazer o timeout da janela!
	UINT m_timeoutPassDlg;

	BOOL DoDialog();

private:
	static BOOL CALLBACK vncAuthDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static BOOL CALLBACK vncNoAuthDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

	UINT m_indiceDominio; // ndice selecionado no combobox de domnios
};

#endif
